﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace ERNW.PowerShell.AdministrativeTemplate.AdmxTemplate
{
    public class TemplateObject
    {
        public GeneralAttributes GeneralAttributes { get; set; } = new GeneralAttributes();
        public SettingAttributes SettingAttributes { get; set; } = new SettingAttributes();
        public string explainText { get; set; }
        public string presentation { get; set; }
    }

    public class GeneralAttributes
    {
        public string FileName { get; set; }
        public PolicyState state { get; set; }
        public ClassType classType { get; set; }
        public string name { get; set; }
        public string displayName { get; set; }
    }

    public class SettingAttributes
    {
        public string key { get; set; }
        public ArrayList elements { get; set; }
        //public List<Element> elements { get; set; }
    }

    public enum ClassType { Machine, User }

    public enum PolicyState { Enabled, Disabled, NotConfigured }

    public enum ValueType { PolicyEnable, Decimal, Boolean, Text, Enum, List }

    public class TextElement : Element
    {
    }

    public class Element
    {
        public string ValueName { get; set; }
        public ValueType ValueType { get; set; }
        public string value { get; set; }
        public bool required { get; set; } = false;
        public string key { get; set; }
    }

    public class decimalElement : Element
    {
        public uint? minValue { get; set; }
        public uint? maxValue { get; set; }
    }

    public class enumElement : Element
    {
        public Dictionary<string, string> valueList { get; set; }
        public int defaultItem { get; set; }
    }

    public class ListElement : Element
    {
        public Dictionary<string, string> valueList { get; set; }
        public Boolean? additive { get; set; }
        public Boolean? explicitValue { get; set; }
    }

    public class PolEnableElement : Element
    {
        public object enabledValue { get; set; }
        public object disabledValue { get; set; }
    }

    public class EnableListElement : Element
    {
        public List<EnabledList> enabledValueList { get; set; }
        public List<EnabledList> disabledValueList { get; set; }
    }

    public class EnabledList
    {
        public string key { get; set; }
        public string valueName { get; set; }
        public ValueType type { get; set; }
        public string value { get; set; }
    }

}
