﻿using System;
using System.IO;
using System.Linq;
using System.Reflection;

namespace ERNW.PowerShell.AdministrativeTemplate.PSAdmxCmdlet
{
    public static class PluginResolver
    {
        private static bool hooked = false;
        public static string PluginBasePath { get; private set; }

        public static void InitPluginResolver(string BasePath)
        {
            PluginBasePath = BasePath;
            if (!hooked)
            {
                AppDomain.CurrentDomain.AssemblyResolve += ResolvePluginAssembly;
                hooked = true;
            }
        }

        internal static Assembly ResolvePluginAssembly(object sender, ResolveEventArgs args)
        {
            var asmName = new AssemblyName(args.Name).Name + ".dll";
            var assemblyFiles = Directory.EnumerateFiles(PluginBasePath, "*.dll", SearchOption.AllDirectories);

            var asmFile = assemblyFiles.FirstOrDefault(fn => string.Compare(Path.GetFileName(fn), asmName, true) == 0);

            if (string.IsNullOrEmpty(asmFile))
                return null;

            return Assembly.LoadFile(asmFile);
        }


    }

    public class CreateDBInfo
    {
        public string dbFileLocation { get; set; }
        public string createTime { get; set; }
    }

    public class BaseTable
    {
        public string base_id { get; set; }
        public string base_name { get; set; }
        public string base_time { get; set; }
        public string base_osversion { get; set; }
        public int base_count { get; set; }
    }

    public class BasePolicyTable
    {
        public string base_id { get; set; }
        public string policies { get; set; }

    }

}
